//+------------------------------------------------------------------+
//|                                               Fractal TrendLines |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1

//
//
//
//
//

extern bool   RayTrendLine          = true;
extern int    TrendLineLookbackBars = 90;
extern double TrendLinePipTolerance = 4;
extern int    Use3TouchPoints       = 1;
extern int    MarkerFontSz          = 8;
extern color  HighLine.Color        = LimeGreen;
extern color  LowLine.Color         = DeepPink;

extern bool   alertsOn              = true;
extern bool   alertsOnCurrent       = true;
extern bool   alertsOnHighLow       = true;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = true;
extern bool   alertsEmail           = false;
extern string soundfile             = "alert2.wav";

//
//
//
//
//

double trend[];
double modifier = 1;

int    digits = 0;

string  Prefix       = "TLB_";
string sComments     = "";
string Circle        = "l";
string DiamondS      = "s";
string DiamondM      = "t";
string DiamondL      = "u";
string Star4Pt       = "";
string ArrowHollowUp = "";
string ArrowHollowDn = "";
string ArrowSolidUp  = "";
string ArrowSolidDn  = "";
string Billard1      = "";
string Billard2      = "";
string Billard3      = "";
string symbol;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   symbol = Symbol();  
   
   SetIndexBuffer(0,trend);
   return(0);
}

//
//
//
//
//

int deinit()
{
   ObjectDelete(Prefix+"FL1");
   ObjectDelete(Prefix+"FL2");
   ObjectDelete(Prefix+"FL3");
   ObjectDelete(Prefix+"LLn");
   ObjectDelete(Prefix+"FH1");
   ObjectDelete(Prefix+"FH2");
   ObjectDelete(Prefix+"FH3");
   ObjectDelete(Prefix+"HLn");
   Comment("");
   
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
   
  	digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
   
      trend[i] = 0;                     
            if (alertsOnHighLow)       
            {
               if (High[i] > HighLine()) trend[i] = 1;
               if (Low[i]  < LowLine() ) trend[i] =-1;
            }
            else
            {
               if (Close[i] > HighLine()) trend[i] = 1;
               if (Close[i] < LowLine() ) trend[i] =-1;
            }
   //
   //
   //
   //
   //
   
   }
   manageAlerts();
return(0);
}
 
//
//
//
//
//       

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(symbol,0,iTime(symbol,0,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"lower trend line");
         if (trend[whichBar] ==-1) doAlert(whichBar,"upper trend line");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];
       message        =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TrendLines crossed ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TrendLines"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double LowLine()
{
      RefreshRates();
      int    LowestLowIndex   = iLowest(NULL,0,MODE_LOW,TrendLineLookbackBars-1,0);
      double LowestLow        = Low[LowestLowIndex];
      double CurrentLineValue = 100000000;
      int    Point2Index      = 0;
      bool   ThirdPoint       = false;
      double Slope;
      double Val;
   
      //
      //
      //
      //
      //
   
      if (Use3TouchPoints != 0)
      {
         DrawTrendLine(Prefix+"LLn",0,0,0,0,true,1,LowLine.Color,2,true); 
         DrawFractal(Prefix+"FL3", 0, "",MarkerFontSz,"WingDings",LowLine.Color,0,0,true); 
      }      

      for (int count = LowestLowIndex - 2; count > 0; count--)
      {
         Val = iFractals(symbol,0,MODE_LOWER, count);
         if (Val < CurrentLineValue && Val > 0 )
      {
            Point2Index      = count;
            CurrentLineValue = Val;
            Slope            = (Low[count] - LowestLow ) / (NormalizeDouble(LowestLowIndex - count,digits));
      }
   }
   
   //
   //
   //
   //
   //
   
   if (Point2Index > 0)
   {
   
      DrawFractal(Prefix+"FL1",0,Billard1,MarkerFontSz,"WingDings",LowLine.Color,Time[LowestLowIndex],Low[LowestLowIndex],false);
      DrawFractal(Prefix+"FL2",0,Billard2,MarkerFontSz,"WingDings",LowLine.Color,Time[Point2Index],Low[Point2Index],false);
    
   
      if (Use3TouchPoints == 0) DrawTrendLine(Prefix+"LLn", Low[LowestLowIndex],Low[Point2Index],Time[LowestLowIndex],Time[Point2Index], RayTrendLine, 1, LowLine.Color, 2, false);
   }
   
   //
   //
   //
   //
   //
   
   if (Use3TouchPoints != 0)
   {
     
      CurrentLineValue += Slope;
      for (int count2 = Point2Index - 1; count2 > 1; count2--)
      {
         CurrentLineValue += Slope;
         Val = iFractals(symbol,0,MODE_LOWER,count2);
 
         if (Val > 0 && MathAbs( CurrentLineValue - Val ) <= TrendLinePipTolerance * modifier)
         {
           ThirdPoint = true;
           
              DrawFractal(Prefix+"FL3",0,Billard3,MarkerFontSz,"WingDings",LowLine.Color,Time[count2],Low[count2],false);
              DrawTrendLine(Prefix+"LLn",Low[LowestLowIndex],CurrentLineValue,Time[LowestLowIndex],Time[count2],RayTrendLine,1,LowLine.Color,2,false);
           break;
         }
      }
      
      //
      //
      //
      //
      //
      
      if (!ThirdPoint) CurrentLineValue = -1;
   }
   
return(CurrentLineValue);
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double HighLine()
{
      RefreshRates();
      int    HighestHighIndex = iHighest(NULL,0,MODE_HIGH,TrendLineLookbackBars-1,0);
      double HighestHigh      = High[HighestHighIndex];
      double CurrentLineValue = -100000000;
      int    Point2Index      = 0;
      bool   ThirdPoint       = false;
      double Slope;
      double Val;
   
      //
      //
      //
      //
      //
   
      if (Use3TouchPoints != 0)
      {
         DrawTrendLine(Prefix+"HLn",0,0,0,0,true,1,HighLine.Color,2,true);
         DrawFractal(Prefix+"FH3", 0, "",MarkerFontSz,"WingDings",HighLine.Color,0,0,true); 
      }
   
      for (int count = HighestHighIndex - 2; count > 0; count--)
      {
 
         Val = iFractals(NULL,0,MODE_UPPER,count);

      if (Val > CurrentLineValue && Val > 0)
      {
         Point2Index      = count;
         CurrentLineValue = Val;
         Slope            = (HighestHigh - High[count]) / (NormalizeDouble(HighestHighIndex - count,digits));
      }
   }
   
   //
   //
   //
   //
   //
   
   if (Point2Index > 0)
   {
   
      DrawFractal(Prefix+"FH1",0,Billard1,MarkerFontSz,"WingDings",HighLine.Color,Time[HighestHighIndex],High[HighestHighIndex],False);
      DrawFractal(Prefix+"FH2",0,Billard2,MarkerFontSz,"WingDings",HighLine.Color,Time[Point2Index],High[Point2Index],False);

      if (Use3TouchPoints == 0) DrawTrendLine(Prefix+"HLn", High[HighestHighIndex], High[Point2Index], Time[HighestHighIndex], Time[Point2Index], RayTrendLine, 1, HighLine.Color, 2, False); 
   }
   
   //
   //
   //
   //
   //
   
   if (Use3TouchPoints != 0)
   {
     
     CurrentLineValue -= Slope;
     for (int count2 = Point2Index - 1; count2 > 1; count2--)
     {
        CurrentLineValue -= Slope;
        Val = iFractals(symbol,0,MODE_UPPER,count2);
 
        if (Val > 0 && MathAbs(CurrentLineValue - Val ) <= TrendLinePipTolerance * modifier)
        {
          ThirdPoint = true;
             DrawFractal(Prefix+"FH3",0,Billard3,MarkerFontSz,"WingDings",HighLine.Color,Time[count2],High[count2],false);
             DrawTrendLine(Prefix+"HLn",High[HighestHighIndex],CurrentLineValue,Time[HighestHighIndex],Time[count2],RayTrendLine,1,HighLine.Color,2,false);
            break;
         }   
      }
      
      //
      //
      //
      //
      //
      
      if (!ThirdPoint) CurrentLineValue = -1;
   }

return(CurrentLineValue);
}

//
//
//
//
//

void DrawTrendLine(string name, double price1, double price2, datetime time1, datetime time2, bool RayLine, int Width, color Color, int Style, bool DeleteOnly)
{  
   if (DeleteOnly) 
      ObjectDelete(name);
   else
   {
      if(ObjectFind(name) != 0)
         ObjectCreate(name,OBJ_TREND,0,0,0,0,0); 

      ObjectSet(name, OBJPROP_TIME1, time1  ); 
      ObjectSet(name, OBJPROP_TIME2, time2  ); 
      ObjectSet(name, OBJPROP_PRICE1,price1 ); 
      ObjectSet(name, OBJPROP_PRICE2,price2 ); 
      ObjectSet(name, OBJPROP_RAY,   RayLine);
      ObjectSet(name, OBJPROP_COLOR, Color  );
      ObjectSet(name, OBJPROP_WIDTH, Width  );
      ObjectSet(name, OBJPROP_STYLE, Style  ); 
   }
}

//
//
//
//
//

void DrawFractal(string TextName, int Window, string LabelText, int FontSz, string FontName, color TextColor, datetime Time1, double Price1, bool DeleteOnly)
{
   if (DeleteOnly) 
      ObjectDelete(TextName);
   else
   {
      if(ObjectFind(TextName) != 0)
      {
         ObjectCreate(TextName, OBJ_TEXT,Window,Time1,Price1);
         ObjectSetText(TextName,LabelText,FontSz,FontName,TextColor);
      }
      else
         ObjectMove(TextName,0,Time1,Price1);
   }
} 

